
// Direction-Map own pathfinding array
var WorkArray[SMALLMAPX][SMALLMAPY];
var error2;

///////////////////////////////////////////////////////////////////
// Direction Map pathfinding function declarations - ending with 00
function PathFind00();
function LookAround00(var a,b);
function Tile_DataArray_Conversion00();
function Work_Equal_Data00();
function Data_Equal_Work00();

action Path_Dots00();
function Create_Path_Array00();

action All_Path_Arrows00();
function DrawAllPaths00();

///////////////////////////////////////////////////////////////////

function Tile_DataArray_Conversion00()
{
	var i,j;

	for(i=0 ; i<GridX ; i++)
	for(j=0 ; j<GridY ; j++)
	{						
		// no access 								// buildings having walkable top remain accessible 
		if (Tiles[i][j] == 1) 
		{
			DataArray[i][j] = 11;      
		}
		else
		{
			DataArray[i][j] = 0;    	
		}
	}  			
}

// checking DataArray and setting WorkArray in the 8 neighbouring nodes of node(a;b) > in a priority order <
function LookAround00(var a,b)
{	
	var am, ap, bp, bm;
	
	am = a-1;
	ap = a+1;
	bm = b-1;
	bp = b+1;

	// the 4 main directions - if neighbour is path (=0) or finish (=10) then overwrites in WorkArray    	
	// S
	if (bm>=0)    
	if ((DataArray[a][bm]==0) || (DataArray[a][bm]==10)) 
	if ( abs( TilesZ[a][b] - TilesZ[a][bm] ) < 3 ) 				// and height difference is less than 3 (ladder or stairs)
	{
		WorkArray[a][bm] = 1 ;
		error2++; 
	}
	// E
	if (ap<GridX) 
	if ((DataArray[ap][b]==0) || (DataArray[ap][b]==10))  
	if ( abs( TilesZ[a][b] - TilesZ[ap][b] ) < 3 )
	{
		WorkArray[ap][b] = 2 ;
		error2++; 
	}
	// N    
	if (bp<GridY) 	
	if ((DataArray[a][bp]==0) || (DataArray[a][bp]==10))   
	if ( abs( TilesZ[a][b] - TilesZ[a][bp] ) < 3 )
	{
		WorkArray[a][bp] = 3 ;
		error2++; 
	}
	// W
	if (am>=0)    
	if ((DataArray[am][b]==0) || (DataArray[am][b]==10))  
	if ( abs( TilesZ[a][b] - TilesZ[am][b] ) < 3 )
	{
		WorkArray[am][b] = 4 ;	
		error2++; 
	}
	
	// the 4 cross-directions
	// now overwrites only if no existing main direction is placed into WorkArray at current position
	// SW
	if ((am>=0) && (bm>=0))  
	if ((DataArray[am][bm]==0) || (DataArray[am][bm]==10))
	if ((WorkArray[am][bm]!=4) && (WorkArray[am][bm]!=1)) 
	if ( abs( TilesZ[a][b] - TilesZ[am][bm] ) == 0 )					// no height difference allowed in diagonal directions - it would result in ugly movements
	{
		WorkArray[am][bm] = 5 ;
		error2++; 
	}
	// SE
	if ((ap<GridX) && (bm>=0)) 
	if ((DataArray[ap][bm]==0) || (DataArray[ap][bm]==10))
	if ((WorkArray[ap][bm]!=1) && (WorkArray[ap][bm]!=2)) 
	if ( abs( TilesZ[a][b] - TilesZ[ap][bm] ) == 0 )
	{
		WorkArray[ap][bm] = 6 ;
		error2++; 
	}
	// NE
	if ((ap<GridX) && (bp<GridY)) 
	if ((DataArray[ap][bp]==0) || (DataArray[ap][bp]==10))
	if ((WorkArray[ap][bp]!=2) && (WorkArray[ap][bp]!=3)) 
	if ( abs( TilesZ[a][b] - TilesZ[ap][bp] ) == 0 )
	{
		WorkArray[ap][bp] = 7 ;
		error2++; 
	}
	// NW
	if ((am>=0) && (bp<GridY)) 
	if ((DataArray[am][bp]==0) || (DataArray[am][bp]==10))
	if ((WorkArray[am][bp]!=3) && (WorkArray[am][bp]!=4))
	if ( abs( TilesZ[a][b] - TilesZ[am][bp] ) == 0 )
	{
		WorkArray[am][bp] = 8 ;
		error2++; 
	}

	//path is complete if finish is overwritten - i.e. not equal to 10 
	if (WorkArray[fx][fy]!=10)
	{
		found = 1;
	}		
}

function Data_Equal_Work00()
{
	var k,m;
	for(m=0 ; m<GridY ; m++)
	for( k=0 ; k<GridX ; k++)			
	DataArray[k][m] =  WorkArray[k][m] ;		
}

function Work_Equal_Data00()
{
	var k,m;	
	for(m=0 ; m<GridY ; m++)
	for( k=0 ; k<GridX ; k++)			
	WorkArray[k][m] =  DataArray[k][m] ;		
}


// pathfinder main function - using a 0-1 based tile system
function PathFind00()
{	
	// no collision detection needed for path entities
	enable_polycollision = 0; 

	// show a panel during calculation
	set( work_in_progress , SHOW );
	//work_in_progress.flags |= SHOW;  
	reset( path_found , SHOW );
	reset( path_error , SHOW );
	wait(5);
	
	time_1 = GetTickCount();
	
	////////// data initialization and path conversion from node system //////////    
	var i,j, error1, counter;
	var tempx,tempy, tempa,tempb;
	
	Tile_DataArray_Conversion00();
	
	// setting startand finish nodes - set before function call
	
	// setting start and finish in data array
	DataArray[sx][sy] = 9;
	DataArray[fx][fy] = 10;    
	
	// WorkArray = DataArray;  // the 2 arrays should be the same now  
	Work_Equal_Data00();
	
	///////////// main process ////////////////
	 
	found = 0 ;	// "finish" not found  
	error1 = 0 ; // no error
	maxpath = MAXPATHLENGTH * 10;  // max loop - to avoid infinite cycle  
	counter = 1 ;  // shows errors or finding destination    
	cycle_time = 0;
	
	// first check from start point - should be separated from loop because strt has no direction value
	LookAround00(sx,sy);

	// DataArray = WorkArray; // DataArray should contain new information made in WorkArray before next loop
	Data_Equal_Work00();
	
	cycle_time++;  // just for checking
	
	// checking loop strarts if not found in first round
	if (!found)
		while ((!found) && (!error1))
		{
			cycle_time++;			
			error2 = 0; // inner loop check to make faster error response
			// looking around the edge of DataArray
			for(j=0 ; j<GridY ; j++)			
				for(i=0 ; i<GridX ; i++)				
					if ((DataArray[i][j]>0) && (DataArray[i][j]<9))	
						{
							LookAround00(i,j);
						}			
			// DataArray = WorkArray; // DataArray should contain new information made in WorkArray before next loop
			Data_Equal_Work00();			
			// no open node found
			if ( error2 == 0) error1++; 
			// to avoid infinite loop, exit while loop
			if ( cycle_time >= maxpath ) error1++; 		
		}
	
	///// error message //////
	if (found<1)
	{
		set( path_error , SHOW );	
		
		pathlength = 0;
		total_move_cost = 0;
		
		if (drawalltiles) DrawAllPaths00(); // to see where calcucation failed
		
		wait(1);
		wait(-2);
		reset( path_error , SHOW );
		
		EndOfPathfinding(); // allow to do something again	
	}
	
	///// creating path array , showing 2D array positions ///////
	if (found>0)
	{
		// found panel
		set( path_found , SHOW );
		// create path array and show path
		Create_Path_Array00();	
	}   // found>0 
	
	// remove panel
	wait(1);
	reset( work_in_progress , SHOW );
	
	// reset collision detection
	enable_polycollision = 1;
}

//// ------------------------------------

// setting path dot properties
action Path_Dots00()
{
	// tile coordinates
	var tempx = my.x;
	var tempy = my.y;	
	// horizintal alignment
	vec_set( my.pan , vector(270,90,0) );       	
	// scale to actual tilesize
	my.scale_x = TileSize/GRIDSIZE;
	my.scale_y = TileSize/GRIDSIZE;	
	// convert tile coordinates to real coordinates
	my.x = TileToCoord( tempx , GridX );
	my.y = TileToCoord( tempy , GridY );	
	SnapIt();	
	// set z
	if ( ((Tiles[tempx][tempy])%HEIGHT_OFFSET) >= MODELS) 
		my.z = TilesMin[tempx][tempy] + TilesZ[tempx][tempy]*TileSize + PathLevel;
	else 
		my.z = TilesMax[tempx][tempy] + PathLevel;	
	set( me , PASSABLE | ZNEAR );		// | ZNEAR - to check hidden tiles
	my.ambient = 100;  
	my.emask &= ~DYNAMIC;
}

function Create_Path_Array00()
{
	var i,j, k, tempx,tempy,tempd, counter,counterm;
	
	//// clearing existing path data ////
	for(i=0 ; i<MAXPATHLENGTH ; i++)
	{
		// pathX and Y store x and y array-coordinates within the range 0..999, so 1000 is the value of no path elements
		pathX[i] = 1000;
		pathY[i] = 1000;
		// pathDir can show in 8 directions or nowhere=0 . it is needed for representing the path by small arrows
		pathDir[i] = 0;
	}
	
	// temporarily the first element of path-array is the finish node
	counter = 0;				
	pathX[counter] = fx;
	pathY[counter] = fy; 
	pathDir[counter] = DataArray[ fx ][ fy ]; // final direction can be any - but practically set to value of dataarray
	maxpath = MAXPATHLENGTH;     // now it shows the global maximum value given 
	
	///// looking for start node backward from finish /////
	while ( ((pathX[counter] != sx) || (pathY[counter] != sy)) && (counter<(maxpath-1)) )
	//for(i=0 ; i<maxpath ; i++ ) // old version loop
	{
		
		// counter now points at the current element
		counter += 1;
		counterm = counter - 1;
		// pointing at the previous elment's position
		tempx = pathX[counterm] ;
		tempy = pathY[counterm] ;
		
		pathDir[counter] = DataArray[ tempx ][ tempy ];	// directions are taken from the dataarray value of prevous position, thus it will point always to next step tile
		
		// searching back the previous node, based on directioncodes 1-8
		// if the previous is to the norh, the the current value is previous.y -1    
		if (DataArray[ tempx ][ tempy ] == 1)										
		{
			pathX[ counter ] = pathX[ counterm ] ;    		
			pathY[ counter ] = pathY[ counterm ] + 1;	
		}
		else if (DataArray[ tempx ][ tempy ] == 2)
		{
			pathX[ counter ] = pathX[ counterm ] - 1;
			pathY[ counter ] = pathY[ counterm ] ;	
		}
		else if (DataArray[ tempx ][ tempy ] == 3)
		{
			pathX[ counter ] = pathX[ counterm ] ;
			pathY[ counter ] = pathY[ counterm ] - 1;	
		}
		else if (DataArray[ tempx ][ tempy ] == 4)
		{
			pathX[ counter ] = pathX[ counterm ] + 1;
			pathY[ counter ] = pathY[ counterm ] ;	
		}
		else if (DataArray[ tempx ][ tempy ] == 5)
		{
			pathX[ counter ] = pathX[ counterm ] + 1;
			pathY[ counter ] = pathY[ counterm ] + 1;	
		}
		else if (DataArray[ tempx ][ tempy ] == 6)
		{
			pathX[ counter ] = pathX[ counterm ] - 1;
			pathY[ counter ] = pathY[ counterm ] + 1;	
		}
		else if (DataArray[ tempx ][ tempy ] == 7)
		{
			pathX[ counter ] = pathX[ counterm ] - 1;
			pathY[ counter ] = pathY[ counterm ] - 1;	
		}
		else if (DataArray[ tempx ][ tempy ] == 8)
		{
			pathX[ counter ] = pathX[ counterm ] + 1;
			pathY[ counter ] = pathY[ counterm ] - 1;	
		}
	} // while
	
	// now it shows the real path length
	maxpath = counter +1;	
	
	////// finalizing the path //////	
	tempx = 0;
	tempy = 0;
	tempd = 0;
	var maxpathlength_minus1_minusi;
	for( i=0; i<maxpath ; i++ )               
	{
		maxpathlength_minus1_minusi = maxpath -1 -i ;  
		// last element to temp
		tempx = pathX[ maxpathlength_minus1_minusi ] ;
		tempy = pathY[ maxpathlength_minus1_minusi ] ;
		tempd = pathDir[ maxpathlength_minus1_minusi ];
		// first element to last
		pathX[ maxpathlength_minus1_minusi ] = pathX[ i ];
		pathY[ maxpathlength_minus1_minusi ] = pathY[ i ];
		pathDir[ maxpathlength_minus1_minusi ] = pathDir[ i ];
		// temp element to first
		pathX[ i ] = tempx;
		pathY[ i ] = tempy;
		pathDir[ i ] = tempd;
	}
	// pathX and Y are ready to use
	
	// get time length of path calculation, and without path display
	time_2 = GetTickCount();
	time_elapsed = (time_2 - time_1)/1000;
	str_for_num(timer_value, time_elapsed);	
	
	///// representing the path //////
	if (drawalltiles)
	{	
		k = 0;
		for( i=0 ; i<maxpath ; i++ )
		{
			if ( (pathX[i] < 1000) && (pathY[i] < 1000) )
			{   		 			
				PathArray[k] = ent_create( path_dot , vector(pathX[i],pathY[i],0) , Path_Dots00 );			
				k++;
			}
		}	
	}
	else
	{
		k = 0;
		for( i=0 ; i<maxpath ; i++ )
		{
			if ( (pathX[i] < 1000) && (pathY[i] < 1000) )
			{   		 			
				if (pathDir[i]==1)		{ PathArray[k] = ent_create( "1.tga" , vector(pathX[i],pathY[i],0) , Path_Dots00 );	 }
				else if (pathDir[i]==2)	{ PathArray[k] = ent_create( "2.tga" , vector(pathX[i],pathY[i],0) , Path_Dots00 );	 }
				else if (pathDir[i]==3)	{ PathArray[k] = ent_create( "3.tga" , vector(pathX[i],pathY[i],0) , Path_Dots00 );	 }
				else if (pathDir[i]==4)	{ PathArray[k] = ent_create( "4.tga" , vector(pathX[i],pathY[i],0) , Path_Dots00 );	 }
				else if (pathDir[i]==5)	{ PathArray[k] = ent_create( "5.tga" , vector(pathX[i],pathY[i],0) , Path_Dots00 );	 }
				else if (pathDir[i]==6)	{ PathArray[k] = ent_create( "6.tga" , vector(pathX[i],pathY[i],0) , Path_Dots00 );	 }
				else if (pathDir[i]==7)	{ PathArray[k] = ent_create( "7.tga" , vector(pathX[i],pathY[i],0) , Path_Dots00 );	 }
				else if (pathDir[i]==8)	{ PathArray[k] = ent_create( "8.tga" , vector(pathX[i],pathY[i],0) , Path_Dots00 );	 }
				else 							{ PathArray[k] = ent_create( path_dot , vector(pathX[i],pathY[i],0) , Path_Dots00 );	}	// error
				k++;
			}
		}	
	}
	
	// display path length
	pathlength = maxpath;
	
	// representing all search values, just for fun
	if (drawalltiles) DrawAllPaths00();	
	
	// removing the little arrays showing all possible directions
	wait(1);
	wait(-10);
	reset( path_found , SHOW );
	
	for(i=0 ; i<k ; i++)
		ptr_remove( PathArray[i] );	
	wait(1);
	
	// get path cost
	Path_Cost_Calculation();
	EndOfPathfinding(); // allow to do something again	
}

////-----------------------------------------

// setting direction signs' position
action All_Path_Arrows00()
{
	// tile coordinates
	var tempx = my.x;
	var tempy = my.y;	
	// horizintal alignment
	vec_set( my.pan , vector(270,90,0) );       	
	// scale to actual tilesize
	my.scale_x = TileSize/GRIDSIZE;
	my.scale_y = TileSize/GRIDSIZE;
	// convert tile coordinates to real coordinates	
	my.x = TileToCoord( tempx , GridX );
	my.y = TileToCoord( tempy , GridY );	
	SnapIt();	
	// set z
	if (Tiles[tempx][tempy]%HEIGHT_OFFSET>=MODELS)  
		my.z = TilesMin[tempx][tempy] + TilesZ[tempx][tempy]*TileSize + PathLevel + RoadLevel;		// lowest - on model
	else 
		my.z = TilesMax[tempx][tempy] + PathLevel + RoadLevel;		// highest - on sprite and ground	
	set( me , PASSABLE );		// | ZNEAR
	my.ambient = 100;
	my.emask &= ~DYNAMIC;
}


// drawing directions stored in DataArray showing all possible path-directions from start point
// each tile arrow shows where it came from - not as path, where to go
function DrawAllPaths00()
{
	var i,j, k;
	var tempx, tempy, tempa, tempb, tempc;
	
	// sprite creation is modified - action is called with tile positions given, and those are converted to coordinate values within the action
	
	// grid origo offset, if vertex 0,0,0 is the middle of the grid
//	tempx = (GridX / 2) * TileSize - (TileSize / 2);  // if 40 then 1248
//	tempy = (GridY / 2) * TileSize - (TileSize / 2);  // if 20 then 672

	k = 0; // entity array counter
	for(j=0 ; j<GridY; j++)
		for(i=0 ; i<GridX; i++)
		{
			// x;y coordinates
//			tempa = ( i * TileSize ) - tempx ;
//			tempb = ( j * TileSize ) - tempy ;
			
//			tempa = TileToCoord( i , GridX );
//			tempb = TileToCoord( j , GridY );
//			tempc = TilesZ[ i ][ j ] *TileSize;
			
			if ( DataArray[i][j] == 0 ) { ArrowArray[k] = ent_create( "0.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
			else if ( DataArray[i][j] == 1 ) { ArrowArray[k] = ent_create( "1.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
			else if ( DataArray[i][j] == 2 ) { ArrowArray[k] = ent_create( "2.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
			else if ( DataArray[i][j] == 3 ) { ArrowArray[k] = ent_create( "3.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
			else if ( DataArray[i][j] == 4 ) { ArrowArray[k] = ent_create( "4.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
			else if ( DataArray[i][j] == 5 ) { ArrowArray[k] = ent_create( "5.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
			else if ( DataArray[i][j] == 6 ) { ArrowArray[k] = ent_create( "6.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
			else if ( DataArray[i][j] == 7 ) { ArrowArray[k] = ent_create( "7.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
			else if ( DataArray[i][j] == 8 ) { ArrowArray[k] = ent_create( "8.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
			else if ( DataArray[i][j] == 9 ) { ArrowArray[k] = ent_create( "9.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
//			else if ( DataArray[i][j] == 10 ) { ArrowArray[k] = ent_create( "10.tga" , vector(i,j,0) , All_Path_Arrows00 ); }		
			else if ( DataArray[i][j] == 11 ) { ArrowArray[k] = ent_create( "11.tga" , vector(i,j,0) , All_Path_Arrows00 ); }
			
			k++;
		}		
	
	// should be drawn separately because finish is overwritten in Data and Work Arrays
//	tempa = ( fx * TileSize ) - tempx ;
//	tempb = ( fy * TileSize ) - tempy ;
	ArrowArray[k] = ent_create( "10.tga" , vector(fx,fy,0) , All_Path_Arrows00 ); 		
	k++;

	// removing the little arrays showing all possible directions
	wait(1);
	wait(-5);
	for(i=0 ; i<k ; i++)
	ptr_remove( ArrowArray[i] );
}

