///////////////////////////////
#include <acknex.h>
#include <default.c>
//#include <d3d9.h>		// for antialiasing - not used
//#include <level.c>		// splash screen and fast terrain height calculator helper functions - not used
#include <mtlFX.c>		// for terraintex.fx multiple detail skinning effect (not shader, works in free edition too)
#include <windows.h>		// to access GetTickCount for timer
///////////////////////////////
// standar map size definitions:
#define SMALLMAPX 128				// should be even number (in case of odd number path array is represented wrongly)
#define SMALLMAPY 128				// should be even number (in case of odd number path array is represented wrongly)
#define SMALLMAPSIZE 16384			// 2D array element number SMALLMAPX * SMALLMAPY
#define MAXPATHLENGTH 1000			// should be multiple of map array size, but heavily depends on map complexity
#define GRIDSIZE 64.0				// basic grid value, used for tile creation, and needed for scaling down tile sized graphic entities e.g. if 32 is used as tile size
////////////////////////////////
// skill naming 
#define ANIMATION skill21			// anim frame
#define XTILE_NUMBER skill22		// 0..127 x pos
#define YTILE_NUMBER skill23		// 0..127 y pos
#define AREA_SIZE  skill24			// area occupied by entity in tiles: 1x1 tile = 1, 2x2 tiles = 2 ...
#define ENTITY_TYPE  skill25		// differentiate between obstacle sprites/models, and other system entities. under 100 it is an deletable obstacle
////////////////////////////////////
// walk point penalties on different terrains:
#define WATER_COST 0			// TILE VALUE : 1 - no access
#define STONE_COST 4			// TILE VALUE : 2
#define DIRT_COST 6			// TILE VALUE : 3
#define GRASS_COST 10		// TILE VALUE : 0 - average value, it has significant influence on A* remaining distance estimation (= heuristic function)
#define WOODS_COST 16		// TILE VALUE : 4
#define SNOW_COST 18			// TILE VALUE : 5 - not used
#define SAND_COST 20			// TILE VALUE : 6 - not used
#define SWAMP_COST 30		// TILE VALUE : 7 - not used
/////////////////////////////////////
// heuristic functions' estimated cost values - based on experience so play with them bravely! - good result heavily depends on actual terrain
#define TEST1_COST 6.75		// MANHATTAN - should be a bit lower than average value to give a good path
#define TEST2_COST 10.0		// average value or higher can cause over-estimation - bad results, shows simply the shortest path without taking into account move cost penalties
#define TEST3_COST 9.0		// DIAGONAL SHORTCUT - should be close to average cost value
#define TEST4_COST 9.5		// EUCLIDIAN - should be a nearly average cost value
//////////////////////////////
#include "maphandling_2D.c"
///////////////////////////////
// terrain skin material settings
MATERIAL* terrain_mat =
{
       effect = "terraintex.fx"; // no shader so it works with free edition too
}
action terrain_action()
{
   my.ENTITY_TYPE = 1000;    // to avoid deletion
	my.material = terrain_mat;
}
///////////////////////     
// to remap f1-f12 
function key_do_nothing() 
{
	wait(1);
}

function main()
{
	// avoid 3dgs calls
	on_f1  = key_do_nothing;
	on_f2  = key_do_nothing;
	on_f3  = key_do_nothing;
	on_f4  = key_do_nothing;
	on_f5  = key_do_nothing;
	on_f6  = key_do_nothing;
	on_f7  = key_do_nothing;
	on_f8  = key_do_nothing;
	on_f9  = key_do_nothing;
	on_f10  = key_do_nothing;
	on_f12 = key_do_nothing;
	on_0 = key_do_nothing;
	
	fps_max = 50; // limit the frame rate
	video_mode = 8; // run in 1024x768 pixels
	video_depth = 32; // start the engine in 32 bit mode
	video_screen = 1; // start in full screen mode
	
//	d3d_antialias = 1;
	preload_mode = 3+4; 
	
	// setting sky color
	sky_color.red = 25;
	sky_color.green = 125;
	sky_color.blue = 175; 
   
	// level load
	max_entities = SMALLMAPX * SMALLMAPY * 2 + MAXPATHLENGTH * 10 + 500;    // reserve enough memory for entities representing the path arrays
//	terrain_chunk=0;		// needed only if more sewed terrains are used 
	level_load(NULL);
	
	// setting sun
	vec_set(sun_color,vector(150,175,200));  
	sun_light = 80;    
	sun_angle.pan = 315; // from South-East
   sun_angle.tilt = 45; 
   
   // setting dynamic shadow type
	mat_shadow.alpha = 35;
	shadow_stencil = 1;
	
	wait(1);
	
	detail_size = -14;	
	terrain_entity = ent_create( "1A.hmp" , vector(0, 0, 0), terrain_action);					
	wait(1);	
	
	// call level settings initialization and handling functions
	Interface_Init();
	
while(1)
        {       		        		
        		wait(1);
        }
	
}