//////////////////////////////////////////////
// user interface
function call_selected_pathfinder();
function toggle_draw_mode();
function toggle_depthfirst();
function change_algorythm(button_number);
function change_buildmode(button_number);

function Load_Map();
function ClearMap();

///////////////////////////////////////////////
// obstacle seeding from bitmap
BMAP* obstacle_map = "seed_map02.bmp";	// obstacle seeding map

//// control panel 1-2
BMAP* pathbtn_on_bmp = "pathbtn_on.bmp";
BMAP* pathbtn_off_bmp = "pathbtn_off.bmp";
BMAP* radiobtn_on_bmp = "radiobtn_on.bmp";
BMAP* radiobtn_off_bmp = "radiobtn_off.bmp";
BMAP* checkbox_on_bmp = "checkbox_on.bmp";
BMAP* checkbox_off_bmp = "checkbox_off.bmp";
BMAP* horiz_slider_bmp = "hslider.bmp";
BMAP* slider_knob_bmp = "hsliderknob.bmp";
BMAP* loadbtn_on_bmp = "loadbtn_on.bmp";
BMAP* loadbtn_off_bmp = "loadbtn_off.bmp";

//////////////// displaying information: TEXT and PANEL definitions
TEXT* info_txt =	
{
  layer = 1;
  pos_x = 512;
  pos_y = 720;
  strings = 1;
  font = "Arial#16b";
  string ("Move/rotate camera by moving mouse to screen edge", "Zoom by mouse wheel" , "Press [SPACE] to clear map" );
  flags = CENTER_X | OUTLINE | SHOW;
} 

PANEL* grid_position =
{
	flags = TRANSLUCENT | SHADOW | SHOW;
	alpha = 75;	
	pos_x = 850; 
	pos_y = 0;
	bmap = "position.bmp";
	layer = 10;	
	
	digits(15, 10, "Coordinates:", "Arial#14b", 0, 0);
	digits(15, 25, "x = %0.f", "Arial#14b", 1, square_coord_x);
	digits(15, 40, "y = %0.f", "Arial#14b", 1, square_coord_y);
	digits(15, 55, "z = %0.f", "Arial#14b", 1, square_coord_z);
	
	digits(15, 70, "Tile position:", "Arial#14b", 0, 0);
	digits(15, 85, "x = %0.f", "Arial#14b", 1, square_x);
	digits(15, 100, "y = %0.f", "Arial#14b", 1, square_y);
	digits(15, 115, "z = %0.f", "Arial#14b", 1, square_z);
	
	digits(85, 40, "TilesZ0 = %0.1f", "Arial#14b", 1, square_valueZ0);
	digits(85, 55, "TilesZ1 = %0.1f", "Arial#14b", 1, square_valueZ1);
	
	digits(85, 85, "Tiles0 = %0.2f", "Arial#14b", 1, square_value0);
	digits(85, 100, "Tiles1 = %0.2f", "Arial#14b", 1, square_value1);
	digits(85, 115, "Tiles2 = %0.2f", "Arial#14b", 1, square_value2);
	
	digits(15, 140, "Build mode: %0.f", "Arial#14b", 1, BuildMode);
	digits(15, 155, "Path draw mode: %0.f", "Arial#14b" , 1, drawalltiles);
	digits(15, 170, "Obstacle size: %0.f", "Arial#14b" , 1, draw_size);
	
	digits(15, 185, "Path type: %0.f", "Arial#14b", 1, path_type);
	digits(15, 200, "Last cycle num: %0.f", "Arial#14b", 1, cycle_time);
	digits(15, 215, "Last path length: %0.f", "Arial#14b", 1, pathlength);
	digits(15, 230, "Last move cost: %0.f", "Arial#14b", 1, total_move_cost);		
}

PANEL* info_panel_1 =
{
	flags = TRANSLUCENT | SHADOW | SHOW | OVERLAY;
	alpha = 75;	
	pos_x = 768; 
	pos_y = 512;
	bmap = "position.bmp";
	layer = 10;	
	
	button_radio (15, 30, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_algorythm, NULL,  NULL);	
	button_radio (15, 50, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_algorythm, NULL, NULL);
	button_radio (15, 70, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_algorythm, NULL, NULL);
	button_radio (15, 90, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_algorythm, NULL, NULL);
	
	button (15, 227.5, pathbtn_on_bmp, pathbtn_off_bmp, pathbtn_on_bmp, call_selected_pathfinder , NULL, NULL);
	button_toggle (15, 170, checkbox_on_bmp, checkbox_off_bmp, checkbox_on_bmp, checkbox_off_bmp, toggle_draw_mode , NULL, NULL);
	button (130, 227.5, loadbtn_on_bmp, loadbtn_off_bmp, loadbtn_on_bmp, Load_Map , NULL, NULL);
	button_toggle (15, 150, checkbox_on_bmp, checkbox_off_bmp, checkbox_on_bmp, checkbox_off_bmp, toggle_turn_mode , NULL, NULL);
	
	slider (15, 192.5, horiz_slider_bmp, slider_knob_bmp, 0, 20, heur_value);
	
	digits(15, 5, "Select a pathfinding algorythm", "Arial#16b", 0, 0);
	digits(35, 30, "[F1] Direction Map (ext. breadth-first)", "Arial#14b", 0, 0);
	digits(35, 50, "[F2] A* with heuristic: Manhattan", "Arial#14b", 0, 0);
	digits(35, 70, "[F3] A* with heuristic: Euclidian", "Arial#14b", 0, 0);
	digits(35, 90, "[F4] A* with heuristic: Diagonal shortcut", "Arial#14b", 0, 0);
	
	digits(35, 110, "[F5] A* without H: Dijktsra", "Arial#14b", 0, 0);
	digits(35, 130, "[F6] A* withuot G: Depth-First", "Arial#14b", 0, 0);
	
	digits(35, 150, "[F10] A* with turn penalty&limit(vehicle)", "Arial#14b", 0, 0);
	digits(35, 170, "[F12] Show only final path (draws faster)", "Arial#14b", 0, 0);
	digits(125, 190, "Heuristic Weight: %0.2f", "Arial#14b", 1, heur_value);
	digits(15, 210, "if this value is 0, A* works as Dijskra", "Arial#14b", 0, 0);
	
	button_radio (15, 110, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_algorythm, NULL, NULL);
	button_toggle (15, 130, checkbox_on_bmp, checkbox_off_bmp, checkbox_on_bmp, checkbox_off_bmp, toggle_depthfirst , NULL, NULL);	
}

PANEL* info_panel_2 =
{
	flags = TRANSLUCENT | SHADOW | SHOW | OVERLAY;
	alpha = 75;	
	pos_x = 0; 
	pos_y = 512;
	bmap = "position.bmp";
	layer = 10;	
		
	button_radio (15, 50, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_buildmode, NULL, NULL);
	button_radio (15, 70, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_buildmode, NULL, NULL);
	button_radio (15, 90, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_buildmode, NULL, NULL);
	button_radio (15, 110, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_buildmode, NULL, NULL);
	button_radio (15, 130, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_buildmode, NULL, NULL);
	button_radio (15, 150, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_buildmode, NULL, NULL);
		
	button_radio (15, 210, radiobtn_on_bmp, radiobtn_off_bmp, radiobtn_off_bmp, change_buildmode, NULL, NULL);
	
	digits(15, 10, "Place obstacles:", "Arial#16b", 0, 0);
	digits(15, 30, "(left click - build, right click - delete)", "Arial#14b", 0, 0);
	digits(35, 50, "[1] water - no access", "Arial#14b", 0, 0);
	digits(35, 70, "[2] stone road - fastest", "Arial#14b", 0, 0);
	digits(35, 90, "[3] dirt road - faster", "Arial#14b", 0, 0);
	digits(35, 110, "[4] 1 level wall", "Arial#14b", 0, 0);
	digits(35, 130, "[5] 1 level tower", "Arial#14b", 0, 0);
	digits(35, 150, "[6] tree - no access, slower area", "Arial#14b", 0, 0);
	
	digits(35, 170, "[a-s-d-f] ladder, [g-h-j-k] 2 level bastion", "Arial#14b", 0, 0);
	
	digits(15, 190, "Modify path:", "Arial#16b", 0, 0);
	digits(40, 210, "[0] replace start and endpoint", "Arial#14b", 0, 0);
	digits(15, 230, "(left click - start, right click - destination)", "Arial#14b", 0, 0);
}

///////////////////////////////////////////

#include "pathdirmap.c"
#include "pathastar.c"
#include "pathastar_turn.c"

//////////////////////////////////////////
// panel function calls

// control panel 1 functions

// start pathfinding
function call_selected_pathfinder()
{
	while (key_any) {wait (1);}
	
	set(wait_txt,SHOW);
	
	if(BuildMode != 255) 
	{
		if (path_type == 1)
		{
			BuildMode = 255;
			PathFind00();
		}
		else if(path_type == 2) 
		{
			BuildMode = 255;
			if (turnlimit == 0) {PathFind01(1);}
			else {PathFind02(1);}
		}
		else if(path_type == 3) 
		{
			BuildMode = 255;
			if (turnlimit == 0) {PathFind01(2);}
			else {PathFind02(2);}
		}
		else if(path_type == 4) 
		{
			BuildMode = 255;
			if (turnlimit == 0) {PathFind01(3);}
			else {PathFind02(3);}
		}
		else if(path_type == 0) 
		{
			BuildMode = 255;
			if (turnlimit == 0) {PathFind01(0);}
			else {PathFind02(0);}
		}
		ChangeMode();
	}
}

// select what to display when path is found
function toggle_draw_mode()
{
	drawalltiles = 1 - drawalltiles; // toggle 0-1 -  1 means draw all the little arrows, 0 means only path dots
}

function toggle_depthfirst()
{
	depthfirst = 1 - depthfirst; // toggle 0-1 -  1 means depthfirst, 0 normal A*
}

function toggle_turn_mode()
{
	turnlimit = 1 - turnlimit; // toggle 0-1 -  1 means turning is limited, 0 means free to turn to any directions
}

// select pathfinder
function change_algorythm(button_number)
{
	if (button_number<5) path_type = button_number;
	else path_type = 0;
	
	// reset heuristic values
	if (button_number==1) heur_value=0; 
	else if (button_number==2) heur_value=TEST1_COST;
	else if (button_number==3) heur_value=TEST4_COST;
	else if (button_number==4) heur_value=TEST3_COST;
	else if (button_number==9) heur_value=0;
}

// control panel 2 function - change what to do by mouse
function change_buildmode(button_number)
{	
	if (button_number == 7) 
	{ BuildMode = 0; }					// replace path endpoint models 
	else 
	{ BuildMode = button_number; }	// 1-6 build/delete obstacles
	
	ChangeMode();							// refresh tile pointer square
}

/////////////////////////////////////////////
// create obstacles from a bitmap
function Load_Map()
{
	var i,j,k;
	var pixel_format;
	var pixel;
	var pixel_alpha;	
	COLOR pixel_color;
	var temp_x, temp_y;
	STRING* temp_str;
	var rnd;
	
	if (BuildMode == 255) return;		// exit function if program is in wait status
	
	ClearMap();
	
	pixel_format  = bmap_lock(obstacle_map,0);				
	for(i=0 ; i<GridX ; i++)
		for(j=0 ; j<GridY ; j++)
		{
			// read pixel
			pixel = pixel_for_bmap( obstacle_map , i , j );	
			// get color and alpha values from pixel
			pixel_to_vec(pixel_color, pixel_alpha, pixel_format, pixel);
			
			// coordinate position
			temp_x = TileToCoord(i,GridX);
			temp_y = TileToCoord(j,GridY);
			// global tile position - used in Align... actions and ...Fill functions
			temp_tx = i;
			temp_ty = j;
			temp_tz = 0;
			
			// reset buildmode - should be set only if needed in action
			BuildMode = 0;
			// reset draw size to default value
			draw_size = 1;	
			
			// make decision what to build based on pixel color read
			
			// do nothing - it will be definitely overwritten by a model's settings
			if ( (pixel_color.red == 225) && (pixel_color.green == 225) && (pixel_color.blue == 225) )
			{ 							
				
			}
			// set start pos
			else if ( (pixel_color.red == 0) && (pixel_color.green == 255) && (pixel_color.blue == 0) )
			{ 											
				sx = i;
				sy = j;
				sz = 0;
				// player is already created, should be modified only
				me = player;
				my.x = temp_x;
				my.y = temp_y;
				my.pan = 180;
				AlignPlayer();		
				
				// set camera
				CameraObject.x = temp_x + TileSize*5;
				CameraObject.y = temp_y - TileSize*5;
				CamAngle = 270+45;
			}
			// set end pos
			else if ( (pixel_color.red == 255) && (pixel_color.green == 0) && (pixel_color.blue == 0) )
			{ 											
				fx = i;
				fy = j;
				fz = 0;
				// flag
				me = destobject;
				my.x = temp_x;
				my.y = temp_y;
				AlignDestFlag();
			}
			// reset to default value
			else if ( (pixel_color.red == 0) && (pixel_color.green == 0) && (pixel_color.blue == 0) )
			{ 				
				TileFill(0,1,1,0,0);
				// build nothing			
			}
			// build water tile		
			else if ( (pixel_color.red == 255) && (pixel_color.green == 255) && (pixel_color.blue == 255) )
			{ 
				BuildMode = 1; // build water - needed for animation in action called by ent_create
				TileFill(1,1,1,0,0);														
				ent_create( watertile, vector( temp_x , temp_y , 0 ), AlignTile);			
			}
			// build stoneroad tile				
			else if ( (pixel_color.red == 50) && (pixel_color.green == 50) && (pixel_color.blue == 50) )
			{ 
				TileFill(2,1,1,0,0);								
				ent_create( stoneroadtile, vector( temp_x , temp_y , 0 ), AlignTile);			
			}
			// build dirtroad tile	
			else if ( (pixel_color.red == 100) && (pixel_color.green == 100) && (pixel_color.blue == 100) )
			{ 
				TileFill(3,1,1,0,0);											
				ent_create( dirtroadtile, vector( temp_x , temp_y , 0 ), AlignTile);			
			}
			// build wall	
			else if ( (pixel_color.red == 255) && (pixel_color.green == 255) && (pixel_color.blue == 0) )
			{ 
				TileFill(1,MODELS+0,1,3,0);														
				ent_create( wallmodel, vector( temp_x , temp_y , 0 ), AlignModel);			
			}			
			// build simple 1 floor tower	
			else if ( (pixel_color.red == 0) && (pixel_color.green == 255) && (pixel_color.blue > 251) )
			{ 													
				draw_size = 3;		// 3x3 area			
				AreaFill(1,MODELS+1,1,3,0);
				ent_create( towermodel, vector( temp_x , temp_y , 0 ), AlignModel);			
				// corners should be impassable
				Tiles[temp_tx-1][temp_ty+1][1]=1;
				Tiles[temp_tx+1][temp_ty+1][1]=1;
				Tiles[temp_tx-1][temp_ty-1][1]=1;
				Tiles[temp_tx+1][temp_ty-1][1]=1;	
				Tiles[temp_tx][temp_ty-1][1]=1;
				Tiles[temp_tx+1][temp_ty][1]=1;		
				if	(pixel_color.blue < 255)
					for (k=0;k<(255-pixel_color.blue);k++)   // 252 rotated x3 , 253 rotated x2 , 254 rotated x1, 255 no rotation 
						RotateEntity(i,j);
			}	
			// build ladder: 0,0,251-255 ; level change area: 5,5,251-255
			else if ( (pixel_color.red == 0) && (pixel_color.green == 0) && (pixel_color.blue > 251) )
			{ 
				// buildmode needed by alignmodel and level change direction settings
				if (pixel_color.blue == 255)				{ BuildMode = 96; }
				else if (pixel_color.blue == 254)		{ BuildMode = 97; }
				else if (pixel_color.blue == 253)		{ BuildMode = 98; }
				else if (pixel_color.blue == 252)		{ BuildMode = 99; }
				
				draw_size = 1;		// its draw area size in tiles
				TileFill(1,MODELS+24,1,1.5,0);
				
				if (BuildMode==96) 
				{							
//					Tiles[temp_tx][temp_ty-1][0]+=0.3;
					
					// 1st floor settings
					Tiles[temp_tx][temp_ty][1]+=0.15;
				}
				else if (BuildMode==97) 
				{
//					Tiles[temp_tx+1][temp_ty][0]+=0.4;
					
					// 1st floor settings
					Tiles[temp_tx][temp_ty][1]+=0.25;
				}
				else if (BuildMode==98) 
				{
//					Tiles[temp_tx][temp_ty+1][0]+=0.1;
					
					// 1st floor settings
					Tiles[temp_tx][temp_ty][1]+=0.35;
				}
				else if (BuildMode==99) 
				{
//					Tiles[temp_tx-1][temp_ty][0]+=0.2;
					
					// 1st floor settings
					Tiles[temp_tx][temp_ty][1]+=0.45;
				}
				
				ent_create(laddermodel1, vector( temp_x , temp_y , 0 ), AlignModel);	
			}	
			// ladder level change area: 5,5,251-255
			else if ( (pixel_color.red == 5) && (pixel_color.green == 5) && (pixel_color.blue > 251) )
			{
				if (pixel_color.blue == 255)				{ Tiles[temp_tx][temp_ty][0]=0.3; }		// BM 96
				else if (pixel_color.blue == 254)		{ Tiles[temp_tx][temp_ty][0]=0.4; }		// BM 97
				else if (pixel_color.blue == 253)		{ Tiles[temp_tx][temp_ty][0]=0.1; }		// BM 98
				else if (pixel_color.blue == 252)		{ Tiles[temp_tx][temp_ty][0]=0.2; }		// BM 99
			}			
			// build 2 level bastion - RotateEntity cannot be used because of level change settings
			else if ( (pixel_color.red == 0) && (pixel_color.green == 200) && (pixel_color.blue > 251) )
			{ 													
				// buildmode needed by alignmodel and level change direction settings
				if (pixel_color.blue == 255)				{ BuildMode = 92; }
				else if (pixel_color.blue == 254)		{ BuildMode = 93; }
				else if (pixel_color.blue == 253)		{ BuildMode = 94; }
				else if (pixel_color.blue == 252)		{ BuildMode = 95; }
				
				draw_size = 3;		// its draw area size in tiles
				AreaFill(1,MODELS+1,MODELS+1,3,3.5);
				ent_create(bastionmodel, vector( temp_x , temp_y , 0 ), AlignModel);		
				
				// tile value modifications:
				
				// 1st floor: corners and middle impassable (middle ladder corresponds to 2nd floor)
				Tiles[temp_tx-1][temp_ty+1][1]=1;
				Tiles[temp_tx+1][temp_ty+1][1]=1;
				Tiles[temp_tx-1][temp_ty-1][1]=1;
				Tiles[temp_tx+1][temp_ty-1][1]=1;
				Tiles[temp_tx][temp_ty][1]=1;
				
				// 2nd floor ladder height settings
				TilesZ[temp_tx][temp_ty][1]-=1.75;
				
				// doors and ladder accessibility depend on tower orientation
				if (BuildMode==92) 
				{
					// 1st floor settings
					Tiles[temp_tx][temp_ty-1][1]=1;
					Tiles[temp_tx+1][temp_ty][1]=1;
					Tiles[temp_tx-1][temp_ty][1]+=0.2;							
					// 2nd floor settings
					Tiles[temp_tx][temp_ty][2]+=0.45;
				}
				else if (BuildMode==93) 
				{
					// 1st floor settings
					Tiles[temp_tx][temp_ty+1][1]=1;
					Tiles[temp_tx+1][temp_ty][1]=1;
					Tiles[temp_tx][temp_ty-1][1]+=0.3;							
					// 2nd floor settings
					Tiles[temp_tx][temp_ty][2]+=0.15;
				}
				else if (BuildMode==94) 
				{
					// 1st floor settings
					Tiles[temp_tx][temp_ty+1][1]=1;
					Tiles[temp_tx-1][temp_ty][1]=1;
					Tiles[temp_tx+1][temp_ty][1]+=0.4;							
					// 2nd floor settings
					Tiles[temp_tx][temp_ty][2]+=0.25;
				}
				else if (BuildMode==95) 
				{
					// 1st floor settings
					Tiles[temp_tx][temp_ty-1][1]=1;
					Tiles[temp_tx-1][temp_ty][1]=1;
					Tiles[temp_tx][temp_ty+1][1]+=0.1;							
					// 2nd floor settings
					Tiles[temp_tx][temp_ty][2]+=0.35;
				}	
			}				
			// build tree
			else if ( (pixel_color.red == 255) && (pixel_color.green == 0) && (pixel_color.blue == 255) )
			{ 														
				BuildMode = 6; // needed for creating proper shadows
				draw_size = 5;	// 5x5 area
				AreaFill(4,1,1,0,0);	// its surroundings have move cost penalty
				TileFill(1,1,1,0,0);	// the tree itself
				
				random_seed(0); 	// starts with a really random initial value
				rnd = random(2);
				
				if (rnd<1) temp_str = treemodel1;
				else temp_str = treemodel2;	
				ent_create(temp_str, vector( temp_x , temp_y , 0 ), AlignModel);	// the visible model
				
				if (rnd<1) temp_str = treeshadowmodel1;
				else temp_str = treeshadowmodel2;						
				ent_create(temp_str, vector( temp_x , temp_y , 0 ), AlignModel2);	// an invisible model for proper shadow																					
			}
		}
	bmap_unlock(obstacle_map);		// close bmap operations
	BuildMode = 0;  // after bmap loaded reset buildmode
	ChangeMode();
}


function ClearMap()
{
	var i,j;
	var temp_x, temp_y;
	
	if (BuildMode == 255) return;		// exit function if program is in wait status
	
	BuildMode = 255;
	for(i=0 ; i<GridX ; i++)
		for(j=0 ; j<GridY ; j++)
		{
			// coordinate position
			temp_x = TileToCoord(i,GridX);
			temp_y = TileToCoord(j,GridY);
			// global tile position - used in Align... actions and ...Fill functions
			temp_tx = i;
			temp_ty = j;
			temp_tz = 0;
			// clear existing entities from actual tile anyway
			RemoveEntity(temp_tx,temp_ty);
			RemoveEntity(temp_tx,temp_ty); // because of double model creation of trees
			// clear Tile values
			TileFill(0,1,1,0,0);			
		}	
	
	// put path endpoints onto ground level	
	sz=0;
	fz=0;
	
	BuildMode = 0;
	ChangeMode();
}
