
// Direction-Map own pathfinding array
var WorkArray[SMALLMAPX][SMALLMAPY][VERTICAL_LEVELS];
var error2;

///////////////////////////////////////////////////////////////////
// Direction Map pathfinding function declarations - ending with 00
function PathFind00();
//function LookInMainDirection(a,b,c,apm,bpm,dir);
function LookAround00(a,b,c);
function Tile_DataArray_Conversion00();
function Work_Equal_Data00();
function Data_Equal_Work00();

action Path_Dots00();
function Create_Path_Array00();

action All_Path_Arrows00();
function DrawAllPaths00();

///////////////////////////////////////////////////////////////////

// it does not require any preprocessing of inter-level accessibility data, checks neighbours and level changes by itself

function Tile_DataArray_Conversion00()
{
	var i,j,k;

	for(k=0 ; k<VERTICAL_LEVELS ; k++)
		for(i=0 ; i<GridX ; i++)
			for(j=0 ; j<GridY ; j++)
			{						
				// no access 								// buildings having walkable top remain accessible 
				if (Tiles[i][j][k]%HEIGHT_OFFSET == 1) 
				{
					DataArray[i][j][k] = 11;      
				}
				else
				{
					DataArray[i][j][k] = 0 + fraction( Tiles[i][j][k] );    	// i.e. =0.xx, thus keeping level change data
				}
			}  			
}


// checking DataArray and setting WorkArray in the 8 neighbouring nodes of node(a;b) > in a priority order <
function LookAround00(a,b,c)
{	
	var am, ap, bp, bm, cp, cm, tempc;
	
	am = a-1;
	ap = a+1;
	bm = b-1;
	bp = b+1;
	cm = c-1;
	cp = c+1;
//	cmm = c-2;
	
	// TilesZ has less dimension by one, so on ground floor it can be -1, 
	// there it should be not checked, but can cause problems in if statements
	tempc = cm;
	if (tempc<0) { tempc = 0; }
	
	// cases of examination: 
	// 1) level change upwards in main directions, 2) level change downwards in main directions, 
	// 3) same level in main directions, 4) same level in secondary directions
	// main directions now the straight moves, secondary directions now the diagonal moves, but this is optional, can be exchanged 
	
	// checking surrounding tiles on the same level
	
	// the 4 main directions - if neighbour is path (=0) or finish (=10) then overwrites in WorkArray    
	// S
	if ( bm>=0 )   
		if ( (integer(DataArray[a][bm][c])==0) || (integer(DataArray[a][bm][c])==10) ) 
			if ( (cm<0) || (abs( TilesZ[a][b][tempc] - TilesZ[a][bm][tempc] ) < MAX_HEIGHT_DIFFERENCE) )				// ground floor or height difference is less than 3 (flat or ladder or stairs)
			{
				WorkArray[a][bm][c] = 1 + fraction(DataArray[a][bm][c]) ;						// direction value + level change indicator
				error2++; 
			}
	// E
	if ( ap<GridX ) 
		if ( (integer(DataArray[ap][b][c])==0) || (integer(DataArray[ap][b][c])==10) )  
			if ( (cm<0) || (abs( TilesZ[a][b][tempc] - TilesZ[ap][b][tempc] ) < MAX_HEIGHT_DIFFERENCE) )				// ground floor or height difference is less than 3 (flat or ladder or stairs)
			{
				WorkArray[ap][b][c] = 2 + fraction(DataArray[ap][b][c]) ;						// direction value + level change indicator
				error2++; 
			}
	// N    
	if ( bp<GridY ) 	
		if ( (integer(DataArray[a][bp][c])==0) || (integer(DataArray[a][bp][c])==10) )   
			if ( (cm<0) || (abs( TilesZ[a][b][tempc] - TilesZ[a][bp][tempc] ) < MAX_HEIGHT_DIFFERENCE) )				// ground floor or height difference is less than 3 (flat or ladder or stairs)
			{
				WorkArray[a][bp][c] = 3 + fraction(DataArray[a][bp][c]) ;						// direction value + level change indicator
				error2++; 
			}
	// W
	if ( am>=0 )    
		if ( (integer(DataArray[am][b][c])==0) || (integer(DataArray[am][b][c])==10) )  
			if ( (cm<0) || (abs( TilesZ[a][b][tempc] - TilesZ[am][b][tempc] ) < MAX_HEIGHT_DIFFERENCE) )				// ground floor or height difference is less than 3 (flat or ladder or stairs)
			{
				WorkArray[am][b][c] = 4 + fraction(DataArray[am][b][c]) ;						// direction value + level change indicator	
				error2++; 
			}
	
	// the 4 cross-directions - ONLY CHECKS THE SAME LEVEL, THUS NO LEVEL CHANGE IS POSSIBLE IN DIAGONAL DIRECTIONS
	// now overwrites only if no existing main direction is placed into WorkArray at current position	
	// SW
	if ( (am>=0) && (bm>=0) )  
		if ( (integer(DataArray[am][bm][c])==0) || (integer(DataArray[am][bm][c])==10) )
			if ( (integer(WorkArray[am][bm][c])!=4) && (integer(WorkArray[am][bm][c])!=1) ) 
				if ( (cm<0) || (abs( TilesZ[a][b][tempc] - TilesZ[am][bm][tempc] ) == 0) )				
				{
					WorkArray[am][bm][c] = 5 + fraction(DataArray[am][bm][c]) ;						// direction value + level change indicator
					error2++; 
				}
	// SE
	if ( (ap<GridX) && (bm>=0) ) 
		if ( (integer(DataArray[ap][bm][c])==0) || (integer(DataArray[ap][bm][c])==10) )
			if ( (integer(WorkArray[ap][bm][c])!=1) && (integer(WorkArray[ap][bm][c])!=2) ) 
				if ( (cm<0) || (abs( TilesZ[a][b][tempc] - TilesZ[ap][bm][tempc] ) == 0) )		
				{
					WorkArray[ap][bm][c] = 6 + fraction(DataArray[ap][bm][c]) ;						// direction value + level change indicator
					error2++; 
				}
	// NE
	if ( ( ap<GridX) && (bp<GridY) ) 
		if ( (integer(DataArray[ap][bp][c])==0) || (integer(DataArray[ap][bp][c])==10) )
			if ( (integer(WorkArray[ap][bp][c])!=2) && (integer(WorkArray[ap][bp][c])!=3) ) 
				if ( (cm<0) || (abs( TilesZ[a][b][tempc] - TilesZ[ap][bp][tempc] ) == 0) )		
				{
					WorkArray[ap][bp][c] = 7 + fraction(DataArray[ap][bp][c]) ;						// direction value + level change indicator
					error2++; 
				}
	// NW
	if ( (am>=0) && (bp<GridY) ) 
		if ( (integer(DataArray[am][bp][c])==0) || (integer(DataArray[am][bp][c])==10) )
			if ( (integer(WorkArray[am][bp][c])!=3) && (integer(WorkArray[am][bp][c])!=4) )
				if ( (cm<0) || (abs( TilesZ[a][b][tempc] - TilesZ[am][bp][tempc] ) == 0) )		
				{
					WorkArray[am][bp][c] = 8 + fraction(DataArray[am][bp][c]) ;						// direction value + level change indicator
					error2++; 
				}
	
	// level change is possible, if fraction is nonzero - checking surrounding tiles on lower and higher level too	
	// now map border check is not necessary because of pre-processed map structure
	if ( fraction(DataArray[a][b][c]) > 0 )
	{
		// no tileZ check is required, it is done during map building, thus if there is fraction value, the other tile must be accessible
		// moving unit check can be added later
		
		// S.U 0.1
		if (( fraction(DataArray[ a ][ b ][ c ]) > 0.08 ) && ( fraction(DataArray[ a ][ b ][ c ]) < 0.12 ))
		{
//			if ( bm>=0 ) 
			{
				if ( (integer(DataArray[a][bm][cp])==0) || (integer(DataArray[a][bm][cp])==10) )
				{
					WorkArray[a][bm][cp] = 1 + fraction(DataArray[a][bm][cp]) ;						// direction value + level change indicator
					error2++; 
				}
			}
		}
		// E.U 0.2
		else if (( fraction(DataArray[ a ][ b ][ c ]) > 0.18 ) && ( fraction(DataArray[ a ][ b ][ c ]) < 0.22 ))
		{
//			if ( ap<GridX ) 
			{
				if ( (integer(DataArray[ap][b][cp])==0) || (integer(DataArray[ap][b][cp])==10) )
				{
					WorkArray[ap][b][cp] = 2 + fraction(DataArray[ap][b][cp]) ;						// direction value + level change indicator
					error2++; 
				}
			}
		}
		// N.U 0.3
		else if (( fraction(DataArray[ a ][ b ][ c ]) > 0.28 ) && ( fraction(DataArray[ a ][ b ][ c ]) < 0.32 ))
		{
//			if ( bp<GridY ) 
			{
				if ( (integer(DataArray[a][bp][cp])==0) || (integer(DataArray[a][bp][cp])==10) )
				{
					WorkArray[a][bp][cp] = 3 + fraction(DataArray[a][bp][cp]) ;						// direction value + level change indicator
					error2++; 
				}
			}
		}
		// W.U 0.4
		else if (( fraction(DataArray[ a ][ b ][ c ]) > 0.38 ) && ( fraction(DataArray[ a ][ b ][ c ]) < 0.42 ))
		{
//			if ( am>=0 )   
			{
				if ( (integer(DataArray[am][b][cp])==0) || (integer(DataArray[am][b][cp])==10) )
				{
					WorkArray[am][b][cp] = 4 + fraction(DataArray[am][b][cp]) ;						// direction value + level change indicator
					error2++; 
				}
			}
		}
		
		// S.D 0.15
		else if (( fraction(DataArray[ a ][ b ][ c ]) > 0.13 ) && ( fraction(DataArray[ a ][ b ][ c ]) < 0.17 ))
		{
//			if ( bm>=0 ) 
			{
				if ( (integer(DataArray[a][bm][cm])==0) || (integer(DataArray[a][bm][cm])==10) ) 
				{
					WorkArray[a][bm][cm] = 1 + fraction(DataArray[a][bm][cm]) ;						// direction value + level change indicator
					error2++; 
				}
			}
		}
		// E.D 0.25
		else if (( fraction(DataArray[ a ][ b ][ c ]) > 0.23 ) && ( fraction(DataArray[ a ][ b ][ c ]) < 0.27 ))
		{
//			if ( ap<GridX ) 
			{
				if ( (integer(DataArray[ap][b][cm])==0) || (integer(DataArray[ap][b][cm])==10) )
				{
					WorkArray[ap][b][cm] = 2 + fraction(DataArray[ap][b][cm]) ;						// direction value + level change indicator
					error2++; 
				}
			}
		}
		// N.D 0.35
		else if (( fraction(DataArray[ a ][ b ][ c ]) > 0.33 ) && ( fraction(DataArray[ a ][ b ][ c ]) < 0.37 ))
		{
//			if ( bp<GridY ) 
			{
				if ( (integer(DataArray[a][bp][cm])==0) || (integer(DataArray[a][bp][cm])==10) ) 
				{
					WorkArray[a][bp][cm] = 3 + fraction(DataArray[a][bp][cm]) ;						// direction value + level change indicator
					error2++; 
				}
			}
		}
		// W.D 0.45
		else if (( fraction(DataArray[ a ][ b ][ c ]) > 0.43 ) && ( fraction(DataArray[ a ][ b ][ c ]) < 0.47 ))
		{
//			if ( am>=0 )    
			{
				if ( (integer(DataArray[am][b][cm])==0) || (integer(DataArray[am][b][cm])==10) )
				{
					WorkArray[am][b][cm] = 4 + fraction(DataArray[am][b][cm]) ;						// direction value + level change indicator
					error2++; 
				}
			}
		}
		
	}		// if fraction value exists
	
		
	//path is complete if finish is overwritten - i.e. not equal to 10 
	if (integer(WorkArray[fx][fy][fz])!=10)
	{
		found = 1;
	}		
}

function Data_Equal_Work00()
{
	var k,m,n;
	for(n=0 ; n<VERTICAL_LEVELS ; n++)
		for(m=0 ; m<GridY ; m++)
			for( k=0 ; k<GridX ; k++)			
				DataArray[k][m][n] =  WorkArray[k][m][n] ;		
}

function Work_Equal_Data00()
{
	var k,m,n;
	for(n=0 ; n<VERTICAL_LEVELS ; n++)
		for(m=0 ; m<GridY ; m++)
			for( k=0 ; k<GridX ; k++)			
				WorkArray[k][m][n] =  DataArray[k][m][n] ;		
}


// pathfinder main function - using a 0-1 based tile system
function PathFind00()
{	
	// no collision detection needed for path entities
	enable_polycollision = 0; 

	// show a panel during calculation
	set( work_in_progress , SHOW );
	//work_in_progress.flags |= SHOW;  
	reset( path_found , SHOW );
	reset( path_error , SHOW );
	wait(5);
	
	time_1 = GetTickCount();
	
	////////// data initialization and path conversion from node system //////////    
	var i,j,k, error1, counter;
	var tempx,tempy,tempz, tempa,tempb,tempc;
	
	Tile_DataArray_Conversion00();
	
	// setting startand finish nodes - set before function call
	
	// setting start and finish in data array
	DataArray[sx][sy][sz] = 9;
	DataArray[fx][fy][fz] = 10;    
	
	// WorkArray = DataArray;  // the 2 arrays should be the same now  
	Work_Equal_Data00();
	
	///////////// main process ////////////////
	
	found = 0 ;	// "finish" not found  
	error1 = 0 ; // no error
	maxpath = MAXPATHLENGTH * 10;  // max loop - to avoid infinite cycle  
	counter = 1 ;  // shows errors or finding destination    
	cycle_time = 0;
	
	// first check from start point - should be separated from loop because strt has no direction value
	LookAround00(sx,sy,sz);

	// DataArray = WorkArray; // DataArray should contain new information made in WorkArray before next loop
	Data_Equal_Work00();
	
	cycle_time++;  // just for checking
	
	// checking loop strarts if not found in first round
	if (!found)
		while ((!found) && (!error1))
		{
			cycle_time++;			
			error2 = 0; // inner loop check to make faster error response
			// looking around the edge of DataArray
					
			for(j=0 ; j<GridY ; j++)			
				for(i=0 ; i<GridX ; i++)	
					for(k=0 ; k<VERTICAL_LEVELS ; k++)			
						if ((integer(DataArray[i][j][k])>0) && (integer(DataArray[i][j][k])<9))	
							{
								LookAround00(i,j,k);
							}			
			// DataArray = WorkArray; // DataArray should contain new information made in WorkArray before next loop
			Data_Equal_Work00();			
			// no open node found
			if ( error2 == 0) error1++; 
			// to avoid infinite loop, exit while loop
			if ( cycle_time >= maxpath ) error1++; 		
		}
	
	///// error message //////
	if (found<1)
	{
		set( path_error , SHOW );	
		
		pathlength = 0;
		total_move_cost = 0;
		
		if (drawalltiles) DrawAllPaths00(); // to see where calcucation failed
		
		wait(1);
		wait(-2);
		reset( path_error , SHOW );
		
		EndOfPathfinding(); // allow to do something again	
	}
	
	///// creating path array , showing 2D array positions ///////
	if (found>0)
	{
		// found panel
		set( path_found , SHOW );
		// create path array and show path
		Create_Path_Array00();			
	}   // found>0 	
	
	// remove panel
	wait(1);
	reset( work_in_progress , SHOW );
		
	// reset collision detection
	enable_polycollision = 1;
}

//// ------------------------------------

// setting path dot properties
action Path_Dots00()
{
	// tile coordinates
	var tempx = my.x;
	var tempy = my.y;	
	var tempz = my.z;	
	// horizintal alignment
	vec_set( my.pan , vector(270,90,0) );       	
	// scale to actual tilesize
	my.scale_x = TileSize/GRIDSIZE;
	my.scale_y = TileSize/GRIDSIZE;	
	// convert tile coordinates to real coordinates
	my.x = TileToCoord( tempx , GridX );
	my.y = TileToCoord( tempy , GridY );	
	SnapIt();		
	
	if (tempz==2)				
	{ my.z = TilesMin[tempx][tempy] + PathLevel + (TilesZ[tempx][tempy][0]+TilesZ[tempx][tempy][1])*TileSize; }
	else if (tempz==1)
	{ my.z = TilesMin[tempx][tempy] + PathLevel + TilesZ[tempx][tempy][0]*TileSize; }
	else 
	{ my.z = TilesMax[tempx][tempy] + PathLevel; }	
			
	set( me , PASSABLE | ZNEAR );		// | ZNEAR - to check hidden tiles
	my.ambient = 100;  
	my.emask &= ~DYNAMIC;
}

function Create_Path_Array00()
{
	var i,j, k, tempx,tempy,tempz, tempd, counter,counterm, tempa,tempb,tempc;
	
	//// clearing existing path data ////
	for(i=0 ; i<MAXPATHLENGTH ; i++)
	{
		// pathX and Y store x and y array-coordinates within the range 0..999, so 1000 is the value of no path elements
		pathX[i] = 1000;
		pathY[i] = 1000;
		pathZ[i] = 1000;
		// pathDir can show in 8 directions or nowhere=0 . it is needed for representing the path by small arrows
		pathDir[i] = 0;
	}
	
	// temporarily the first element of path-array is the finish node
	counter = 0;				
	pathX[counter] = fx;
	pathY[counter] = fy; 
	pathZ[counter] = fz; 
	pathDir[counter] = integer(DataArray[ fx ][ fy ][ fz ]); // final direction can be any - but practically set to value of dataarray
	maxpath = MAXPATHLENGTH;     // now it shows the global maximum value given 
	
	///// looking for start node backward from finish /////
	while ( ((pathX[counter] != sx) || (pathY[counter] != sy) || (pathZ[counter] != sz)) && (counter<(maxpath-1)) )		// 
	{		
		// counter now points at the current element
		counter += 1;
		counterm = counter - 1;
		// pointing at the previous elment's position
		tempx = pathX[counterm] ;
		tempy = pathY[counterm] ;
		tempz = pathZ[counterm] ;
		
		// directions are taken from the dataarray value of prevous position, thus it will point always to next step tile		
		pathDir[counter] = integer( DataArray[ tempx ][ tempy ][ tempz ] );	
		
		// searching back the previous node, based on directioncodes 1-8
		// if the previous shows to North, the the current position is to the South from there i.e. if 3 then (x;y-1)
		if ( integer(DataArray[ tempx ][ tempy ][ tempz ]) == 1 )										
		{
			pathX[ counter ] = pathX[ counterm ] ;    		
			pathY[ counter ] = pathY[ counterm ] + 1;	
		}
		else if ( integer(DataArray[ tempx ][ tempy ][ tempz ]) == 2 )
		{
			pathX[ counter ] = pathX[ counterm ] - 1;
			pathY[ counter ] = pathY[ counterm ] ;	
		}
		else if ( integer(DataArray[ tempx ][ tempy ][ tempz ]) == 3 )
		{
			pathX[ counter ] = pathX[ counterm ] ;
			pathY[ counter ] = pathY[ counterm ] - 1;	
		}
		else if ( integer(DataArray[ tempx ][ tempy ][ tempz ]) == 4 )
		{
			pathX[ counter ] = pathX[ counterm ] + 1;
			pathY[ counter ] = pathY[ counterm ] ;	
		}
		else if ( integer(DataArray[ tempx ][ tempy ][ tempz ]) == 5 )
		{
			pathX[ counter ] = pathX[ counterm ] + 1;
			pathY[ counter ] = pathY[ counterm ] + 1;	
		}
		else if ( integer(DataArray[ tempx ][ tempy ][ tempz ]) == 6 )
		{
			pathX[ counter ] = pathX[ counterm ] - 1;
			pathY[ counter ] = pathY[ counterm ] + 1;	
		}
		else if ( integer(DataArray[ tempx ][ tempy ][ tempz ]) == 7 )
		{
			pathX[ counter ] = pathX[ counterm ] - 1;
			pathY[ counter ] = pathY[ counterm ] - 1;	
		}
		else if ( integer(DataArray[ tempx ][ tempy ][ tempz ]) == 8 )
		{
			pathX[ counter ] = pathX[ counterm ] + 1;
			pathY[ counter ] = pathY[ counterm ] - 1;	
		}
//		
		// level changer are assigned by +0.1/0.2/0.3/0.4 up , and +0.15/0.25/0.35/0.45 down
		// so if the previous value fraction is 0.1 , we are one level lower now i.e. must go down	
		tempa = pathX[counter] ;
		tempb = pathY[counter] ;
		tempc = pathZ[counter] ;	

		if ( fraction(DataArray[ tempx ][ tempy ][ tempz ]) > 0 )																								
		{
			if ( (( fraction(DataArray[ tempx ][ tempy ][ tempz ]) > 0.08 ) && ( fraction(DataArray[ tempx ][ tempy ][ tempz ]) < 0.12 ) && (pathDir[counterm]!=1) && (pathDir[counter]==3))
			  || (( fraction(DataArray[ tempx ][ tempy ][ tempz ]) > 0.18 ) && ( fraction(DataArray[ tempx ][ tempy ][ tempz ]) < 0.22 ) && (pathDir[counterm]!=2) && (pathDir[counter]==4))
			  || (( fraction(DataArray[ tempx ][ tempy ][ tempz ]) > 0.28 ) && ( fraction(DataArray[ tempx ][ tempy ][ tempz ]) < 0.32 ) && (pathDir[counterm]!=3) && (pathDir[counter]==1))
			  || (( fraction(DataArray[ tempx ][ tempy ][ tempz ]) > 0.38 ) && ( fraction(DataArray[ tempx ][ tempy ][ tempz ]) < 0.42 ) && (pathDir[counterm]!=4) && (pathDir[counter]==2)) )				
			{ 
				pathZ[ counter ] = pathZ[ counterm ] +1; 
			}
			if ( (( fraction(DataArray[ tempx ][ tempy ][ tempz ]) > 0.13 ) && ( fraction(DataArray[ tempx ][ tempy ][ tempz ]) < 0.17 ) && (pathDir[counterm]!=1) && (pathDir[counter]==3)) 
			  || (( fraction(DataArray[ tempx ][ tempy ][ tempz ]) > 0.23 ) && ( fraction(DataArray[ tempx ][ tempy ][ tempz ]) < 0.27 ) && (pathDir[counterm]!=2) && (pathDir[counter]==4)) 
			  || (( fraction(DataArray[ tempx ][ tempy ][ tempz ]) > 0.33 ) && ( fraction(DataArray[ tempx ][ tempy ][ tempz ]) < 0.37 ) && (pathDir[counterm]!=3) && (pathDir[counter]==1)) 
			  || (( fraction(DataArray[ tempx ][ tempy ][ tempz ]) > 0.43 ) && ( fraction(DataArray[ tempx ][ tempy ][ tempz ]) < 0.47 ) && (pathDir[counterm]!=4) && (pathDir[counter]==2)) )	
			{
				pathZ[ counter ] = pathZ[ counterm ] -1; 
			}
		}
		if (pathZ[ counter ]==1000)
		{
			pathZ[ counter ] = pathZ[ counterm ]; 
		}
		
	} // while
	
	// now it shows the real path length
	maxpath = counter +1;	
	
	////// finalizing the path //////
	tempx = 0;
	tempy = 0;
	tempz = 0;
	tempd = 0;
	var maxpathlength_minus1_minusi;
	for( i=0; i<maxpath ; i++ )               
	{
		maxpathlength_minus1_minusi = maxpath -1 -i ;  
		// last element to temp
		tempx = pathX[ maxpathlength_minus1_minusi ] ;
		tempy = pathY[ maxpathlength_minus1_minusi ] ;
		tempz = pathZ[ maxpathlength_minus1_minusi ] ;
		tempd = pathDir[ maxpathlength_minus1_minusi ];
		// first element to last
		pathX[ maxpathlength_minus1_minusi ] = pathX[ i ];
		pathY[ maxpathlength_minus1_minusi ] = pathY[ i ];
		pathZ[ maxpathlength_minus1_minusi ] = pathZ[ i ];
		pathDir[ maxpathlength_minus1_minusi ] = pathDir[ i ];
		// temp element to first
		pathX[ i ] = tempx;
		pathY[ i ] = tempy;
		pathZ[ i ] = tempz;
		pathDir[ i ] = tempd;
	}
	// pathX and Y are ready to use
	
	// get time length of path calculation, and without path display
	time_2 = GetTickCount();
	time_elapsed = (time_2 - time_1)/1000;
	str_for_num(timer_value, time_elapsed);
	
	///// representing the path in 2 different ways //////
	if (drawalltiles)	// by dots
	{	
		k = 0;
		for( i=0 ; i<maxpath ; i++ )
		{
			if ( (pathX[i] < 1000) && (pathY[i] < 1000) && (pathZ[i] < 1000) )
			{   		 			
				PathArray[k] = ent_create( path_dot , vector(pathX[i],pathY[i],pathZ[i]) , Path_Dots00 );			
				k++;
			}
		}	
	}
	else	// by arrows
	{
		k = 0;
		for( i=0 ; i<maxpath ; i++ )
		{
			if ( (pathX[i] < 1000) && (pathY[i] < 1000) && (pathZ[i] < 1000) )
			{   		 			
				if (pathDir[i]==1)		{ PathArray[k] = ent_create( "1.tga" , vector(pathX[i],pathY[i],pathZ[i]) , Path_Dots00 );	 }
				else if (pathDir[i]==2)	{ PathArray[k] = ent_create( "2.tga" , vector(pathX[i],pathY[i],pathZ[i]) , Path_Dots00 );	 }
				else if (pathDir[i]==3)	{ PathArray[k] = ent_create( "3.tga" , vector(pathX[i],pathY[i],pathZ[i]) , Path_Dots00 );	 }
				else if (pathDir[i]==4)	{ PathArray[k] = ent_create( "4.tga" , vector(pathX[i],pathY[i],pathZ[i]) , Path_Dots00 );	 }
				else if (pathDir[i]==5)	{ PathArray[k] = ent_create( "5.tga" , vector(pathX[i],pathY[i],pathZ[i]) , Path_Dots00 );	 }
				else if (pathDir[i]==6)	{ PathArray[k] = ent_create( "6.tga" , vector(pathX[i],pathY[i],pathZ[i]) , Path_Dots00 );	 }
				else if (pathDir[i]==7)	{ PathArray[k] = ent_create( "7.tga" , vector(pathX[i],pathY[i],pathZ[i]) , Path_Dots00 );	 }
				else if (pathDir[i]==8)	{ PathArray[k] = ent_create( "8.tga" , vector(pathX[i],pathY[i],pathZ[i]) , Path_Dots00 );	 }
				else 							{ PathArray[k] = ent_create( path_dot , vector(pathX[i],pathY[i],pathZ[i]) , Path_Dots00 );	}		// error
				k++;
			}
		}	
	}
	
	// display path length
	pathlength = maxpath;
	
	// representing all search values, just for fun
	if (drawalltiles) DrawAllPaths00();
	
	// removing the little arrays showing all possible directions
	wait(1);
	wait(-10);
	reset( path_found , SHOW );
	
	for(i=0 ; i<k ; i++)
		ptr_remove( PathArray[i] );
	wait(1);
		
	// get path cost
	if (!drawalltiles)
	{
		Path_Cost_Calculation();
		EndOfPathfinding(); // allow to do something again		
	}
}

////-----------------------------------------

// setting direction signs' position
action All_Path_Arrows00()
{
	// tile coordinates
	var tempx = my.x;
	var tempy = my.y;	
	var tempz = my.z;	
	// horizintal alignment
	vec_set( my.pan , vector(270,90,0) );       	
	// scale to actual tilesize
	my.scale_x = TileSize/GRIDSIZE;
	my.scale_y = TileSize/GRIDSIZE;
	// convert tile coordinates to real coordinates	
	my.x = TileToCoord( tempx , GridX );
	my.y = TileToCoord( tempy , GridY );	
	SnapIt();	
	
	// set z
//	my.z = TilesMax[tempx][tempy] + PathLevel + RoadLevel + (tempz*TileSize*3); // constant height on each level - can be useful with ZNEAR
	
	if (tempz==2)				
	{ my.z = TilesMax[tempx][tempy] + PathLevel + RoadLevel + (TilesZ[tempx][tempy][0]+TilesZ[tempx][tempy][1])*TileSize; }
	else if (tempz==1)
	{ my.z = TilesMax[tempx][tempy] + PathLevel + RoadLevel + TilesZ[tempx][tempy][0]*TileSize; }
	else 
	{ my.z = TilesMax[tempx][tempy] + PathLevel + RoadLevel; }	
	
	set( me , PASSABLE );		// | ZNEAR
	my.ambient = 100;
	my.emask &= ~DYNAMIC;
}


// drawing directions stored in DataArray showing all possible path-directions from start point
// each tile arrow shows where it came from - not as path, where to go
function DrawAllPaths00()
{
	var i,j,m, k;
	
	for(m=0 ; m<VERTICAL_LEVELS; m++)		// represent arrow arrays level by level
	{
		k = 0; // entity array counter
		for(j=0 ; j<GridY; j++)
			for(i=0 ; i<GridX; i++)
			{		
				if ( integer(DataArray[i][j][m]) == 0 ) 
				{ 					
					ArrowArray[k] = ent_create( "0.tga" , vector(i,j,m) , All_Path_Arrows00 ); // not examined 
				}
				else if ( integer(DataArray[i][j][m]) == 1 ) { ArrowArray[k] = ent_create( "1.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
				else if ( integer(DataArray[i][j][m]) == 2 ) { ArrowArray[k] = ent_create( "2.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
				else if ( integer(DataArray[i][j][m]) == 3 ) { ArrowArray[k] = ent_create( "3.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
				else if ( integer(DataArray[i][j][m]) == 4 ) { ArrowArray[k] = ent_create( "4.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
				else if ( integer(DataArray[i][j][m]) == 5 ) { ArrowArray[k] = ent_create( "5.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
				else if ( integer(DataArray[i][j][m]) == 6 ) { ArrowArray[k] = ent_create( "6.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
				else if ( integer(DataArray[i][j][m]) == 7 ) { ArrowArray[k] = ent_create( "7.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
				else if ( integer(DataArray[i][j][m]) == 8 ) { ArrowArray[k] = ent_create( "8.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
				else if ( integer(DataArray[i][j][m]) == 9 ) { ArrowArray[k] = ent_create( "9.tga" , vector(i,j,m) , All_Path_Arrows00 ); }		// start
	//			else if ( integer(DataArray[i][j][m]) == 10 ) { ArrowArray[k] = ent_create( "10.tga" , vector(i,j,m) , All_Path_Arrows00 ); }		// end - it is overwritten by a direction value, so useless now
				else if ( integer(DataArray[i][j][m]) == 11 ) { ArrowArray[k] = ent_create( "11.tga" , vector(i,j,m) , All_Path_Arrows00 ); }		// obstacle
				
//				// temporary datacheck instead of normal directions it shows level changes
//				if ( fraction(DataArray[i][j][m]) == 0 ) 
//				{ 					
//					ArrowArray[k] = ent_create( "0.tga" , vector(i,j,m) , All_Path_Arrows00 ); // not examined 
//				}
//				else if (( fraction(DataArray[i][j][m]) > 0.08 ) && ( fraction(DataArray[i][j][m]) < 0.12 )) { ArrowArray[k] = ent_create( "1.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
//				else if (( fraction(DataArray[i][j][m]) > 0.18 ) && ( fraction(DataArray[i][j][m]) < 0.22 )) { ArrowArray[k] = ent_create( "2.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
//				else if (( fraction(DataArray[i][j][m]) > 0.28 ) && ( fraction(DataArray[i][j][m]) < 0.32 )) { ArrowArray[k] = ent_create( "3.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
//				else if (( fraction(DataArray[i][j][m]) > 0.38 ) && ( fraction(DataArray[i][j][m]) < 0.42 )) { ArrowArray[k] = ent_create( "4.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
//				else if (( fraction(DataArray[i][j][m]) > 0.13 ) && ( fraction(DataArray[i][j][m]) < 0.17 )) { ArrowArray[k] = ent_create( "1.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
//				else if (( fraction(DataArray[i][j][m]) > 0.23 ) && ( fraction(DataArray[i][j][m]) < 0.27 )) { ArrowArray[k] = ent_create( "2.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
//				else if (( fraction(DataArray[i][j][m]) > 0.33 ) && ( fraction(DataArray[i][j][m]) < 0.37 )) { ArrowArray[k] = ent_create( "3.tga" , vector(i,j,m) , All_Path_Arrows00 ); }
//				else if (( fraction(DataArray[i][j][m]) > 0.43 ) && ( fraction(DataArray[i][j][m]) < 0.47 )) { ArrowArray[k] = ent_create( "4.tga" , vector(i,j,m) , All_Path_Arrows00 ); }				
//				// orig.
//				else if ( integer(DataArray[i][j][m]) == 9 ) { ArrowArray[k] = ent_create( "9.tga" , vector(i,j,m) , All_Path_Arrows00 ); }		// start
//				else if ( integer(DataArray[i][j][m]) == 11 ) { ArrowArray[k] = ent_create( "11.tga" , vector(i,j,m) , All_Path_Arrows00 ); }		// obstacle
				
				k++;
			}		// for i j 
	
		// should be drawn separately because finish is overwritten in Data and Work Arrays
		ArrowArray[k] = ent_create( "10.tga" , vector(fx,fy,fz) , All_Path_Arrows00 ); 		
		k++;
		
		// removing the little arrays showing all possible directions
		wait(1);
		wait(-3);
		for(i=0 ; i<k ; i++)
			ptr_remove( ArrowArray[i] );	
	}	// for m
	
	Path_Cost_Calculation();
	EndOfPathfinding(); // allow to do something again		
}

